local bids = {}
local rolls = {}
local bidActive = false
local rollActive = false
local link = nil
local minbid = 0
local updateInterval = 1.0; 
local countdown = 3
local countdownActive = false
local ticker = {}
local frameID = 0
local lootChannel = "RAID"
local announceChannel = "RAID_WARNING"

local CLASS_COLORS = {
    warrior = {0.78, 0.61, 0.43},
    hunter = {0.67, 0.83, 0.45},
    rogue = {1.00, 0.96, 0.41},
    priest = {1.00, 1.00, 1.00},
    shaman = {0.00, 0.44, 0.87},
    mage = {0.41, 0.80, 0.94},
    warlock = {0.58, 0.51, 0.79},
    druid = {1.00, 0.49, 0.04},
};

function Ragequit:AuctionItemLink()
	return link
end

function Ragequit:ContainerFrameItemButton_OnModifiedClick(self, button)
	if button == "RightButton" and IsAltKeyDown() and not CursorHasItem() then
		if Ragequit:IsInRaid() then
			local _, itemLink = GetItemInfo(GetContainerItemID(self:GetParent():GetID(), self:GetID()))
			link = itemLink

			if Ragequit:isItemBOE(link) then
				Ragequit:HandleAuctionCommand(link)
			else
				StaticPopup_Show("RQAUCTIONPOPUP", link)
			end
		end
	end
end

function Ragequit:Roll(message)
	if rollActive then
		if string.match(message, "(.+) rolls (%d+) %((%d+)-(%d+)%)") ~= nil then 
			local character, rollResult, rollMin, rollMax = string.match(message, "(.+) rolls (%d+) %((%d+)-(%d+)%)");

			if rollMin == "1" and rollMax == "100" then
				rolls[character] = rollResult

			end
		end
	end
end

function Ragequit:Bid(character, message)
	if bidActive then 
		local character = stripRealm(character)

		if string.match(message:lower(), 'bid %d+') ~= nil then
			local dkp = tonumber(string.match(message, '%d+'))

			if dkp < 10000 then
				if dkp >= minbid then			
					if Ragequit:IsBidHigher(dkp, character, 5) then
						bids[character] = dkp
						if countdownActive then
							Ragequit:CancelCountDown()
						end
					end
				else
					SendChatMessage(string.format("%s bid på %s må være høyere enn %s", character, dkp, minbid) ,lootChannel);
				end
			end
		elseif string.match(message:lower(), 'bid all %d+') ~= nil then
			local dkp = tonumber(string.match(message, '%d+'))

			if dkp < 10000 then			
				if Ragequit:IsBidHigher(dkp, character, 1) then
					bids[character] = dkp
					if countdownActive then
						Ragequit:CancelCountDown()
					end
				end
			end
		end
    end
end

function Ragequit:IsBidHigher(dkp, character, minus)
	if tablelength(bids) == 0 then
		return true
	end

	local found = true

	for k, v in pairs(bids) do
		local cbid = dkp - minus

        if (v > cbid) then
            found = false
        end
    end

    if found == false then
    	SendChatMessage(string.format("%s bid på %s må være mer enn %s DKP enn forrige bid.", character, dkp, minus) ,lootChannel);
    	return false
    else
    	return true
    end
end

function Ragequit:GetHighestBidder()
	local sortedBids = getKeysSortedByValue(bids, function(a, b) return a > b end)

	for _, character in ipairs(sortedBids) do
		return character, bids[character]
	end
end

function Ragequit:StartCountDown(frame)
	countdownActive = true
	countdown = 5
	local winner, winbid = Ragequit:GetHighestBidder()
	SendChatMessage(string.format("3. %s er høyest med %s DKP for %s", winner, winbid, link) ,lootChannel);
	ticker = C_Timer.NewTicker(2, function()
		if countdown > 0 then
			SendChatMessage(string.format("%s", countdown) ,lootChannel);
			countdown = countdown - 1
		else 
			bidActive = false
			Ragequit:CancelCountDown()
			frame:Hide()

			local winner, winbid = Ragequit:GetHighestBidder()
			SendChatMessage(string.format("%s vant %s med %s DKP", winner, link, winbid) ,lootChannel);
			bids = {}
		end
	end)
end

function Ragequit:GoOffspec(frame)
	minbid = math.ceil(DKP_calc(link, 1) / 2)
	bids = {}
	bidActive = true
	frame:Hide()

	SendChatMessage(string.format("Starter OS bid med %s for %s", minbid, link), announceChannel);
	Ragequit:BidFrame(true, false);
end

function Ragequit:CancelCountDown()
	ticker:Cancel()
	countdownActive = false
end

function Ragequit:isItemBOE(item)
	local _, _, _, _, _, _, _, _, _, _, _, _, _, bindType, _, _, _ = GetItemInfo(item)

	if (bindType == 2) or (bindType == 0) then 
		return true
	else
		return false
	end
end

function Ragequit:itemQuality(item)
	local _, _, quality, _, _, _, _, _, _, _, _, _, _, _ , _, _, _ = GetItemInfo(item)

	return quality
end

function Ragequit:CHAT_MSG_RAID_LEADER(channel, message, character)
    Ragequit:Bid(character, message)
end

function Ragequit:CHAT_MSG_RAID(channel, message, character)
    Ragequit:Bid(character, message)
end

function Ragequit:CHAT_MSG_PARTY_LEADER(channel, message, character)
	Ragequit:Bid(character, message)
end

function Ragequit:CHAT_MSG_PARTY(channel, message, character)
	Ragequit:Bid(character, message)
end

function Ragequit:CHAT_MSG_SYSTEM(channel, message)
	-- Ragequit:Roll(message)
end

function Ragequit:IsInRaid()
	if Ragequit:isDebugMode() then
		return IsInGroup()
	else
		return IsInRaid()
	end
end

-- handle auction command

function Ragequit:HandleAuctionCommand(input)
	if Ragequit:isDebugMode() then
		lootChannel = "PARTY"
	end

	if Ragequit:IsInRaid() then
		if (string.match(input, ".-|h|r") ~= nil) then
			link = string.match(input, ".-|h|r")

			if Ragequit:isItemBOE(link) then
				SendChatMessage(string.format("Roll MS %s", link), lootChannel);
				-- rolls = {}
				-- rollActive = true
			else
				minbid = DKP_calc(link, 1)
				bids = {}
				bidActive = true

				SendChatMessage(string.format("Starter MS bid med %s for %s", minbid, link), announceChannel);
				Ragequit:BidFrame(false, false);
			end
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("Not in Raid")
	end
end

function Ragequit:HandleAuctionOSCommand(input) 
	if Ragequit:isDebugMode() then
		lootChannel = "PARTY"
	end

	if Ragequit:IsInRaid() then
		if (string.match(input, ".-|h|r") ~= nil) then
			link = string.match(input, ".-|h|r")
			minbid = math.ceil(DKP_calc(link, 1) / 2)
			bids = {}
			bidActive = true

			SendChatMessage(string.format("Starter OS bid med %s for %s", minbid, link), announceChannel);
			Ragequit:BidFrame(true, false);
		end
	else
		DEFAULT_CHAT_FRAME:AddMessage("Not in Raid")
	end
end

local function GetCloseButton(frame)
    local kids = { frame:GetChildren() };
    for _, child in ipairs(kids) do
        return child
    end
end

function Ragequit:CancelBid(frame)
	bidActive = false
	frame:Hide()
end

function Ragequit:BidFrame(offspec, roll)

	local frame = CreateFrame("FRAME", string.format("RagequitBidFrame%d", frameID), UIParent, "RagequitBidFrameWindow");
	frameID = frameID + 1
	local _, _, id, name = string.find(link, ".*item:(%d+).-%[(.-)%]|h|r");
	frame.Title:SetText(name);
	frame.Icon.Texture:SetTexture(GetItemIcon(id));
	frame.StartCountDown:SetText("Fullfør");
	frame:Show();

	GetCloseButton(frame):SetScript("OnClick", function () Ragequit:CancelBid(frame) end);

	-- tooltip
	frame.Icon:SetScript("OnEnter", function()
        GameTooltip:SetOwner(UIParent, "ANCHOR_NONE");
        GameTooltip:SetPoint("BOTTOMRIGHT", frame.Icon, "TOPLEFT");
        GameTooltip:SetHyperlink(link);
        GameTooltip_ShowCompareItem();
    end);
    frame.Icon:SetScript("OnLeave", function()
        GameTooltip:Hide();
    end);

    frame.StartCountDown:Disable();
    frame.GoOffspec:Disable();

    if offspec == false then
		frame.GoOffspec:SetScript("OnClick", function () Ragequit:GoOffspec(frame) end);
		frame.GoOffspec:Enable();
	end

	frame.StartCountDown:SetScript("OnClick", function () Ragequit:StartCountDown(frame) end);

	local function GetOrCreateBidRow(i)
        local row = _G[string.format("%sBidderListRow%d", frame:GetName(), i)];
        if not row then

            row = CreateFrame("FRAME", string.format("$parentRow%d", i), frame.BidderList);
            row:SetSize(180, 15);
            row:SetPoint("TOPLEFT", frame.BidderList, "TOPLEFT", 5, 12 + (-15 * i));

            local bid = row:CreateFontString();
            row.bid = bid;
            bid:SetFont("Fonts\\FRIZQT__.TTF", 12);
            bid:SetPoint("TOPLEFT", row, "TOPLEFT");

            local character = row:CreateFontString();
            row.character = character;
            character:SetFont("Fonts\\FRIZQT__.TTF", 12);
            character:SetPoint("TOPLEFT", row, "TOPLEFT", 40, 0);

			local cancel = CreateFrame("Button", nil, row, "UIPanelCloseButtonNoScripts");
			row.cancel = cancel;
			cancel:SetSize(20, 20);
			cancel:SetPoint("TOPLEFT", row, "TOPLEFT", 150, 4);

        end
        return row
    end

	frame:SetScript("OnUpdate", function(self, elapsed)

		self.TimeSinceLastUpdate = self.TimeSinceLastUpdate + elapsed;

		if (self.TimeSinceLastUpdate > updateInterval) then

			local sortedBids = getKeysSortedByValue(bids, function(a, b) return a > b end)

			frame.BidderList:SetHeight(15 * #sortedBids);
			frame:SetHeight(88 + 15 * math.max(3, #sortedBids));

			if #sortedBids > 0 then
				local winner, winbid = Ragequit:GetHighestBidder()
				frame.StartCountDown:SetText(string.format("%s %s DKP", winner, winbid));
				frame.StartCountDown:Enable();

				local i = 1
				for _, character in ipairs(sortedBids) do
					local row = GetOrCreateBidRow(i);
					-- print(bids[character] .. ":" .. character)
					row.bid:SetText(bids[character]);
					row.character:SetText(character);
					row.cancel:SetScript("OnClick", function() Ragequit:RemoveBid(row, character) end);
					row:Show();
					i = i + 1
				end
			end

			self.TimeSinceLastUpdate = 0;
		end
	end);

	return frame
end



function Ragequit:RemoveBid(row, character)
	bids[character] = nil
	row:Hide()
end